<?php

namespace \Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XRoutePlan StructType
 * @subpackage Structs
 */
class XRoutePlan extends AbstractStructBase
{
    /**
     * The dnOrPattern
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 255
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $dnOrPattern;
    /**
     * The partition
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $partition;
    /**
     * The type
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $type;
    /**
     * The routeDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $routeDetail;
    /**
     * Constructor method for XRoutePlan
     * @uses XRoutePlan::setDnOrPattern()
     * @uses XRoutePlan::setPartition()
     * @uses XRoutePlan::setType()
     * @uses XRoutePlan::setRouteDetail()
     * @param string $dnOrPattern
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $partition
     * @param string $type
     * @param string $routeDetail
     */
    public function __construct($dnOrPattern = null, \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $partition = null, $type = null, $routeDetail = null)
    {
        $this
            ->setDnOrPattern($dnOrPattern)
            ->setPartition($partition)
            ->setType($type)
            ->setRouteDetail($routeDetail);
    }
    /**
     * Get dnOrPattern value
     * @return string
     */
    public function getDnOrPattern()
    {
        return $this->dnOrPattern;
    }
    /**
     * Set dnOrPattern value
     * @param string $dnOrPattern
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XRoutePlan
     */
    public function setDnOrPattern($dnOrPattern = null)
    {
        $this->dnOrPattern = $dnOrPattern;
        return $this;
    }
    /**
     * Get partition value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public function getPartition()
    {
        return $this->partition;
    }
    /**
     * Set partition value
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $partition
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XRoutePlan
     */
    public function setPartition(\\Losc\CucmBundle\Model\Webservice\StructType\XFkType $partition = null)
    {
        $this->partition = $partition;
        return $this;
    }
    /**
     * Get type value
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XRoutePlan
     */
    public function setType($type = null)
    {
        $this->type = $type;
        return $this;
    }
    /**
     * Get routeDetail value
     * @return string
     */
    public function getRouteDetail()
    {
        return $this->routeDetail;
    }
    /**
     * Set routeDetail value
     * @param string $routeDetail
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XRoutePlan
     */
    public function setRouteDetail($routeDetail = null)
    {
        $this->routeDetail = $routeDetail;
        return $this;
    }
}
